local CalendarConstants =
{
	Tables =
	{
		{
			Name = "CalendarCommandType",
			Type = "Enumeration",
			NumValues = 12,
			MinValue = 0,
			MaxValue = 11,
			Fields =
			{
				{ Name = "Create", Type = "CalendarCommandType", EnumValue = 0 },
				{ Name = "Invite", Type = "CalendarCommandType", EnumValue = 1 },
				{ Name = "Rsvp", Type = "CalendarCommandType", EnumValue = 2 },
				{ Name = "RemoveInvite", Type = "CalendarCommandType", EnumValue = 3 },
				{ Name = "RemoveEvent", Type = "CalendarCommandType", EnumValue = 4 },
				{ Name = "Status", Type = "CalendarCommandType", EnumValue = 5 },
				{ Name = "ModeratorStatus", Type = "CalendarCommandType", EnumValue = 6 },
				{ Name = "GetCalendar", Type = "CalendarCommandType", EnumValue = 7 },
				{ Name = "GetEvent", Type = "CalendarCommandType", EnumValue = 8 },
				{ Name = "UpdateEvent", Type = "CalendarCommandType", EnumValue = 9 },
				{ Name = "Complain", Type = "CalendarCommandType", EnumValue = 10 },
				{ Name = "Notes", Type = "CalendarCommandType", EnumValue = 11 },
			},
		},
		{
			Name = "CalendarErrorType",
			Type = "Enumeration",
			NumValues = 51,
			MinValue = 0,
			MaxValue = 50,
			Fields =
			{
				{ Name = "Success", Type = "CalendarErrorType", EnumValue = 0 },
				{ Name = "CommunityEventsExceeded", Type = "CalendarErrorType", EnumValue = 1 },
				{ Name = "EventsExceeded", Type = "CalendarErrorType", EnumValue = 2 },
				{ Name = "SelfInvitesExceeded", Type = "CalendarErrorType", EnumValue = 3 },
				{ Name = "OtherInvitesExceeded", Type = "CalendarErrorType", EnumValue = 4 },
				{ Name = "NoPermission", Type = "CalendarErrorType", EnumValue = 5 },
				{ Name = "EventInvalid", Type = "CalendarErrorType", EnumValue = 6 },
				{ Name = "NotInvited", Type = "CalendarErrorType", EnumValue = 7 },
				{ Name = "UnknownError", Type = "CalendarErrorType", EnumValue = 8 },
				{ Name = "NotInGuild", Type = "CalendarErrorType", EnumValue = 9 },
				{ Name = "NotInCommunity", Type = "CalendarErrorType", EnumValue = 10 },
				{ Name = "TargetAlreadyInvited", Type = "CalendarErrorType", EnumValue = 11 },
				{ Name = "NameNotFound", Type = "CalendarErrorType", EnumValue = 12 },
				{ Name = "WrongFaction", Type = "CalendarErrorType", EnumValue = 13 },
				{ Name = "Ignored", Type = "CalendarErrorType", EnumValue = 14 },
				{ Name = "InvitesExceeded", Type = "CalendarErrorType", EnumValue = 15 },
				{ Name = "InvalidMaxSize", Type = "CalendarErrorType", EnumValue = 16 },
				{ Name = "InvalidDate", Type = "CalendarErrorType", EnumValue = 17 },
				{ Name = "InvalidTime", Type = "CalendarErrorType", EnumValue = 18 },
				{ Name = "NoInvites", Type = "CalendarErrorType", EnumValue = 19 },
				{ Name = "NeedsTitle", Type = "CalendarErrorType", EnumValue = 20 },
				{ Name = "EventPassed", Type = "CalendarErrorType", EnumValue = 21 },
				{ Name = "EventLocked", Type = "CalendarErrorType", EnumValue = 22 },
				{ Name = "DeleteCreatorFailed", Type = "CalendarErrorType", EnumValue = 23 },
				{ Name = "DataAlreadySet", Type = "CalendarErrorType", EnumValue = 24 },
				{ Name = "CalendarDisabled", Type = "CalendarErrorType", EnumValue = 25 },
				{ Name = "RestrictedAccount", Type = "CalendarErrorType", EnumValue = 26 },
				{ Name = "ArenaEventsExceeded", Type = "CalendarErrorType", EnumValue = 27 },
				{ Name = "RestrictedLevel", Type = "CalendarErrorType", EnumValue = 28 },
				{ Name = "Squelched", Type = "CalendarErrorType", EnumValue = 29 },
				{ Name = "NoInvite", Type = "CalendarErrorType", EnumValue = 30 },
				{ Name = "ComplaintDisabled", Type = "CalendarErrorType", EnumValue = 31 },
				{ Name = "ComplaintSelf", Type = "CalendarErrorType", EnumValue = 32 },
				{ Name = "ComplaintSameGuild", Type = "CalendarErrorType", EnumValue = 33 },
				{ Name = "ComplaintGm", Type = "CalendarErrorType", EnumValue = 34 },
				{ Name = "ComplaintLimit", Type = "CalendarErrorType", EnumValue = 35 },
				{ Name = "ComplaintNotFound", Type = "CalendarErrorType", EnumValue = 36 },
				{ Name = "EventWrongServer", Type = "CalendarErrorType", EnumValue = 37 },
				{ Name = "NoCommunityInvites", Type = "CalendarErrorType", EnumValue = 38 },
				{ Name = "InvalidSignup", Type = "CalendarErrorType", EnumValue = 39 },
				{ Name = "NoModerator", Type = "CalendarErrorType", EnumValue = 40 },
				{ Name = "ModeratorRestricted", Type = "CalendarErrorType", EnumValue = 41 },
				{ Name = "InvalidNotes", Type = "CalendarErrorType", EnumValue = 42 },
				{ Name = "InvalidTitle", Type = "CalendarErrorType", EnumValue = 43 },
				{ Name = "InvalidDescription", Type = "CalendarErrorType", EnumValue = 44 },
				{ Name = "InvalidClub", Type = "CalendarErrorType", EnumValue = 45 },
				{ Name = "CreatorNotFound", Type = "CalendarErrorType", EnumValue = 46 },
				{ Name = "EventThrottled", Type = "CalendarErrorType", EnumValue = 47 },
				{ Name = "InviteThrottled", Type = "CalendarErrorType", EnumValue = 48 },
				{ Name = "Internal", Type = "CalendarErrorType", EnumValue = 49 },
				{ Name = "ComplaintAdded", Type = "CalendarErrorType", EnumValue = 50 },
			},
		},
		{
			Name = "CalendarEventBits",
			Type = "Enumeration",
			NumValues = 15,
			MinValue = 1,
			MaxValue = 3788,
			Fields =
			{
				{ Name = "Player", Type = "CalendarEventBits", EnumValue = 1 },
				{ Name = "GuildDeprecated", Type = "CalendarEventBits", EnumValue = 2 },
				{ Name = "System", Type = "CalendarEventBits", EnumValue = 4 },
				{ Name = "Holiday", Type = "CalendarEventBits", EnumValue = 8 },
				{ Name = "Locked", Type = "CalendarEventBits", EnumValue = 16 },
				{ Name = "AutoApprove", Type = "CalendarEventBits", EnumValue = 32 },
				{ Name = "CommunityAnnouncement", Type = "CalendarEventBits", EnumValue = 64 },
				{ Name = "RaidLockout", Type = "CalendarEventBits", EnumValue = 128 },
				{ Name = "ArenaDeprecated", Type = "CalendarEventBits", EnumValue = 256 },
				{ Name = "RaidReset", Type = "CalendarEventBits", EnumValue = 512 },
				{ Name = "CommunitySignup", Type = "CalendarEventBits", EnumValue = 1024 },
				{ Name = "GuildSignup", Type = "CalendarEventBits", EnumValue = 2048 },
				{ Name = "CommunityWide", Type = "CalendarEventBits", EnumValue = 3136 },
				{ Name = "PlayerCreated", Type = "CalendarEventBits", EnumValue = 3395 },
				{ Name = "CantComplain", Type = "CalendarEventBits", EnumValue = 3788 },
			},
		},
		{
			Name = "CalendarEventRepeatOptions",
			Type = "Enumeration",
			NumValues = 4,
			MinValue = 0,
			MaxValue = 3,
			Fields =
			{
				{ Name = "Never", Type = "CalendarEventRepeatOptions", EnumValue = 0 },
				{ Name = "Weekly", Type = "CalendarEventRepeatOptions", EnumValue = 1 },
				{ Name = "Biweekly", Type = "CalendarEventRepeatOptions", EnumValue = 2 },
				{ Name = "Monthly", Type = "CalendarEventRepeatOptions", EnumValue = 3 },
			},
		},
		{
			Name = "CalendarEventType",
			Type = "Enumeration",
			NumValues = 6,
			MinValue = 0,
			MaxValue = 5,
			Fields =
			{
				{ Name = "Raid", Type = "CalendarEventType", EnumValue = 0 },
				{ Name = "Dungeon", Type = "CalendarEventType", EnumValue = 1 },
				{ Name = "PvP", Type = "CalendarEventType", EnumValue = 2 },
				{ Name = "Meeting", Type = "CalendarEventType", EnumValue = 3 },
				{ Name = "Other", Type = "CalendarEventType", EnumValue = 4 },
				{ Name = "HeroicDeprecated", Type = "CalendarEventType", EnumValue = 5 },
			},
		},
		{
			Name = "CalendarFilterFlags",
			Type = "Enumeration",
			NumValues = 5,
			MinValue = 1,
			MaxValue = 16,
			Fields =
			{
				{ Name = "WeeklyHoliday", Type = "CalendarFilterFlags", EnumValue = 1 },
				{ Name = "Darkmoon", Type = "CalendarFilterFlags", EnumValue = 2 },
				{ Name = "Battleground", Type = "CalendarFilterFlags", EnumValue = 4 },
				{ Name = "RaidLockout", Type = "CalendarFilterFlags", EnumValue = 8 },
				{ Name = "RaidReset", Type = "CalendarFilterFlags", EnumValue = 16 },
			},
		},
		{
			Name = "CalendarGetEventType",
			Type = "Enumeration",
			NumValues = 3,
			MinValue = 0,
			MaxValue = 2,
			Fields =
			{
				{ Name = "Get", Type = "CalendarGetEventType", EnumValue = 0 },
				{ Name = "Add", Type = "CalendarGetEventType", EnumValue = 1 },
				{ Name = "Copy", Type = "CalendarGetEventType", EnumValue = 2 },
			},
		},
		{
			Name = "CalendarHolidayFilterType",
			Type = "Enumeration",
			NumValues = 3,
			MinValue = 0,
			MaxValue = 2,
			Fields =
			{
				{ Name = "Weekly", Type = "CalendarHolidayFilterType", EnumValue = 0 },
				{ Name = "Darkmoon", Type = "CalendarHolidayFilterType", EnumValue = 1 },
				{ Name = "Battleground", Type = "CalendarHolidayFilterType", EnumValue = 2 },
			},
		},
		{
			Name = "CalendarInviteBits",
			Type = "Enumeration",
			NumValues = 4,
			MinValue = 1,
			MaxValue = 8,
			Fields =
			{
				{ Name = "PendingInvite", Type = "CalendarInviteBits", EnumValue = 1 },
				{ Name = "Moderator", Type = "CalendarInviteBits", EnumValue = 2 },
				{ Name = "Creator", Type = "CalendarInviteBits", EnumValue = 4 },
				{ Name = "Signup", Type = "CalendarInviteBits", EnumValue = 8 },
			},
		},
		{
			Name = "CalendarInviteSortType",
			Type = "Enumeration",
			NumValues = 6,
			MinValue = 0,
			MaxValue = 5,
			Fields =
			{
				{ Name = "Name", Type = "CalendarInviteSortType", EnumValue = 0 },
				{ Name = "Level", Type = "CalendarInviteSortType", EnumValue = 1 },
				{ Name = "Class", Type = "CalendarInviteSortType", EnumValue = 2 },
				{ Name = "Status", Type = "CalendarInviteSortType", EnumValue = 3 },
				{ Name = "Party", Type = "CalendarInviteSortType", EnumValue = 4 },
				{ Name = "Notes", Type = "CalendarInviteSortType", EnumValue = 5 },
			},
		},
		{
			Name = "CalendarInviteType",
			Type = "Enumeration",
			NumValues = 2,
			MinValue = 0,
			MaxValue = 1,
			Fields =
			{
				{ Name = "Normal", Type = "CalendarInviteType", EnumValue = 0 },
				{ Name = "Signup", Type = "CalendarInviteType", EnumValue = 1 },
			},
		},
		{
			Name = "CalendarModeratorStatus",
			Type = "Enumeration",
			NumValues = 3,
			MinValue = 0,
			MaxValue = 2,
			Fields =
			{
				{ Name = "None", Type = "CalendarModeratorStatus", EnumValue = 0 },
				{ Name = "Moderator", Type = "CalendarModeratorStatus", EnumValue = 1 },
				{ Name = "Creator", Type = "CalendarModeratorStatus", EnumValue = 2 },
			},
		},
		{
			Name = "CalendarStatus",
			Type = "Enumeration",
			NumValues = 9,
			MinValue = 0,
			MaxValue = 8,
			Fields =
			{
				{ Name = "Invited", Type = "CalendarStatus", EnumValue = 0 },
				{ Name = "Available", Type = "CalendarStatus", EnumValue = 1 },
				{ Name = "Declined", Type = "CalendarStatus", EnumValue = 2 },
				{ Name = "Confirmed", Type = "CalendarStatus", EnumValue = 3 },
				{ Name = "Out", Type = "CalendarStatus", EnumValue = 4 },
				{ Name = "Standby", Type = "CalendarStatus", EnumValue = 5 },
				{ Name = "Signedup", Type = "CalendarStatus", EnumValue = 6 },
				{ Name = "NotSignedup", Type = "CalendarStatus", EnumValue = 7 },
				{ Name = "Tentative", Type = "CalendarStatus", EnumValue = 8 },
			},
		},
		{
			Name = "CalendarTexturesType",
			Type = "Enumeration",
			NumValues = 2,
			MinValue = 0,
			MaxValue = 1,
			Fields =
			{
				{ Name = "Dungeons", Type = "CalendarTexturesType", EnumValue = 0 },
				{ Name = "Raid", Type = "CalendarTexturesType", EnumValue = 1 },
			},
		},
		{
			Name = "CalendarType",
			Type = "Enumeration",
			NumValues = 8,
			MinValue = 0,
			MaxValue = 7,
			Fields =
			{
				{ Name = "Player", Type = "CalendarType", EnumValue = 0 },
				{ Name = "Community", Type = "CalendarType", EnumValue = 1 },
				{ Name = "RaidLockout", Type = "CalendarType", EnumValue = 2 },
				{ Name = "RaidReset", Type = "CalendarType", EnumValue = 3 },
				{ Name = "Holiday", Type = "CalendarType", EnumValue = 4 },
				{ Name = "HolidayWeekly", Type = "CalendarType", EnumValue = 5 },
				{ Name = "HolidayDarkmoon", Type = "CalendarType", EnumValue = 6 },
				{ Name = "HolidayBattleground", Type = "CalendarType", EnumValue = 7 },
			},
		},
		{
			Name = "CalendarWebActionType",
			Type = "Enumeration",
			NumValues = 7,
			MinValue = 0,
			MaxValue = 6,
			Fields =
			{
				{ Name = "Accept", Type = "CalendarWebActionType", EnumValue = 0 },
				{ Name = "Decline", Type = "CalendarWebActionType", EnumValue = 1 },
				{ Name = "Remove", Type = "CalendarWebActionType", EnumValue = 2 },
				{ Name = "ReportSpam", Type = "CalendarWebActionType", EnumValue = 3 },
				{ Name = "Signup", Type = "CalendarWebActionType", EnumValue = 4 },
				{ Name = "Tentative", Type = "CalendarWebActionType", EnumValue = 5 },
				{ Name = "TentativeSignup", Type = "CalendarWebActionType", EnumValue = 6 },
			},
		},
		{
			Name = "HolidayCalendarFlags",
			Type = "Enumeration",
			NumValues = 2,
			MinValue = 1,
			MaxValue = 2,
			Fields =
			{
				{ Name = "Alliance", Type = "HolidayCalendarFlags", EnumValue = 1 },
				{ Name = "Horde", Type = "HolidayCalendarFlags", EnumValue = 2 },
			},
		},
		{
			Name = "HolidayFlags",
			Type = "Enumeration",
			NumValues = 6,
			MinValue = 1,
			MaxValue = 32,
			Fields =
			{
				{ Name = "IsRegionwide", Type = "HolidayFlags", EnumValue = 1 },
				{ Name = "DontShowInCalendar", Type = "HolidayFlags", EnumValue = 2 },
				{ Name = "DontDisplayEnd", Type = "HolidayFlags", EnumValue = 4 },
				{ Name = "DontDisplayBanner", Type = "HolidayFlags", EnumValue = 8 },
				{ Name = "NotAvailableClientSide", Type = "HolidayFlags", EnumValue = 16 },
				{ Name = "DurationUseMinutes", Type = "HolidayFlags", EnumValue = 32 },
			},
		},
		{
			Name = "CalendarGetEventTypeConstants",
			Type = "Constants",
			Values =
			{
				{ Name = "DEFAULT_CALENDAR_GET_EVENT_TYPE", Type = "CalendarGetEventType", Value = Get },
			},
		},
	},
};

APIDocumentation:AddDocumentationTable(CalendarConstants);