local SimpleEditBoxAPI =
{
	Name = "SimpleEditBoxAPI",
	Type = "ScriptObject",

	Functions =
	{
		{
			Name = "AddHistoryLine",
			Type = "Function",

			Arguments =
			{
				{ Name = "text", Type = "string", Nilable = false },
			},
		},
		{
			Name = "ClearFocus",
			Type = "Function",

			Arguments =
			{
			},
		},
		{
			Name = "ClearHighlightText",
			Type = "Function",

			Arguments =
			{
			},
		},
		{
			Name = "ClearHistory",
			Type = "Function",

			Arguments =
			{
			},
		},
		{
			Name = "Disable",
			Type = "Function",

			Arguments =
			{
			},
		},
		{
			Name = "Enable",
			Type = "Function",

			Arguments =
			{
			},
		},
		{
			Name = "GetAltArrowKeyMode",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "altMode", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "GetBlinkSpeed",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "cursorBlinkSpeedSec", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetCursorPosition",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "cursorPosition", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetDisplayText",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "displayText", Type = "string", Nilable = false },
			},
		},
		{
			Name = "GetFont",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "name", Type = "string", Nilable = false },
				{ Name = "fontHeight", Type = "number", Nilable = false },
				{ Name = "flags", Type = "string", Nilable = false },
			},
		},
		{
			Name = "GetFontObject",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "font", Type = "table", Nilable = false },
			},
		},
		{
			Name = "GetHighlightColor",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "colorR", Type = "number", Nilable = false },
				{ Name = "colorG", Type = "number", Nilable = false },
				{ Name = "colorB", Type = "number", Nilable = false },
				{ Name = "colorA", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetHistoryLines",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "numHistoryLines", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetIndentedWordWrap",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "isIndented", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "GetInputLanguage",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "language", Type = "string", Nilable = false },
			},
		},
		{
			Name = "GetJustifyH",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "justifyH", Type = "string", Nilable = false },
			},
		},
		{
			Name = "GetJustifyV",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "justifyV", Type = "string", Nilable = false },
			},
		},
		{
			Name = "GetMaxBytes",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "maxBytes", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetMaxLetters",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "maxLetters", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetNumLetters",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "numLetters", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetNumber",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "number", Type = "number", Nilable = true },
			},
		},
		{
			Name = "GetShadowColor",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "colorR", Type = "number", Nilable = false },
				{ Name = "colorG", Type = "number", Nilable = false },
				{ Name = "colorB", Type = "number", Nilable = false },
				{ Name = "colorA", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetShadowOffset",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "offsetX", Type = "number", Nilable = false },
				{ Name = "offsetY", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetSpacing",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "fontHeight", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetText",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "text", Type = "string", Nilable = false },
			},
		},
		{
			Name = "GetTextColor",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "colorR", Type = "number", Nilable = false },
				{ Name = "colorG", Type = "number", Nilable = false },
				{ Name = "colorB", Type = "number", Nilable = false },
				{ Name = "colorA", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetTextInsets",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "left", Type = "number", Nilable = false },
				{ Name = "right", Type = "number", Nilable = false },
				{ Name = "top", Type = "number", Nilable = false },
				{ Name = "bottom", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetUTF8CursorPosition",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "cursorPosition", Type = "number", Nilable = false },
			},
		},
		{
			Name = "GetVisibleTextByteLimit",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "maxVisibleBytes", Type = "number", Nilable = false },
			},
		},
		{
			Name = "HasFocus",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "hasFocus", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "HasText",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "hasText", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "HighlightText",
			Type = "Function",

			Arguments =
			{
				{ Name = "start", Type = "number", Nilable = false, Default = 0 },
				{ Name = "stop", Type = "number", Nilable = false, Default = -1 },
			},
		},
		{
			Name = "Insert",
			Type = "Function",

			Arguments =
			{
				{ Name = "text", Type = "string", Nilable = false },
			},
		},
		{
			Name = "IsAutoFocus",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "autoFocus", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "IsCountInvisibleLetters",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "countInvisibleLetters", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "IsEnabled",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "isEnabled", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "IsInIMECompositionMode",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "isInIMECompositionMode", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "IsMultiLine",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "multiline", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "IsNumeric",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "isNumeric", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "IsPassword",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "isPassword", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "IsSecureText",
			Type = "Function",

			Arguments =
			{
			},

			Returns =
			{
				{ Name = "isSecure", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "SetAltArrowKeyMode",
			Type = "Function",

			Arguments =
			{
				{ Name = "altMode", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetAutoFocus",
			Type = "Function",

			Arguments =
			{
				{ Name = "autoFocus", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetBlinkSpeed",
			Type = "Function",

			Arguments =
			{
				{ Name = "cursorBlinkSpeedSec", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetCountInvisibleLetters",
			Type = "Function",

			Arguments =
			{
				{ Name = "countInvisibleLetters", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetCursorPosition",
			Type = "Function",

			Arguments =
			{
				{ Name = "cursorPosition", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetEnabled",
			Type = "Function",

			Arguments =
			{
				{ Name = "enabled", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetFocus",
			Type = "Function",

			Arguments =
			{
			},
		},
		{
			Name = "SetFont",
			Type = "Function",

			Arguments =
			{
				{ Name = "fontFile", Type = "string", Nilable = false },
				{ Name = "height", Type = "number", Nilable = false },
				{ Name = "flags", Type = "string", Nilable = false },
			},

			Returns =
			{
				{ Name = "success", Type = "bool", Nilable = false },
			},
		},
		{
			Name = "SetFontObject",
			Type = "Function",

			Arguments =
			{
				{ Name = "font", Type = "table", Nilable = false },
			},
		},
		{
			Name = "SetHighlightColor",
			Type = "Function",

			Arguments =
			{
				{ Name = "colorR", Type = "number", Nilable = false },
				{ Name = "colorG", Type = "number", Nilable = false },
				{ Name = "colorB", Type = "number", Nilable = false },
				{ Name = "a", Type = "number", Nilable = true },
			},
		},
		{
			Name = "SetHistoryLines",
			Type = "Function",

			Arguments =
			{
				{ Name = "numHistoryLines", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetIndentedWordWrap",
			Type = "Function",

			Arguments =
			{
				{ Name = "isIndented", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetJustifyH",
			Type = "Function",

			Arguments =
			{
				{ Name = "justifyH", Type = "string", Nilable = false },
			},
		},
		{
			Name = "SetJustifyV",
			Type = "Function",

			Arguments =
			{
				{ Name = "justifyV", Type = "string", Nilable = false },
			},
		},
		{
			Name = "SetMaxBytes",
			Type = "Function",

			Arguments =
			{
				{ Name = "maxBytes", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetMaxLetters",
			Type = "Function",

			Arguments =
			{
				{ Name = "maxLetters", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetMultiLine",
			Type = "Function",

			Arguments =
			{
				{ Name = "multiline", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetNumber",
			Type = "Function",

			Arguments =
			{
				{ Name = "number", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetNumeric",
			Type = "Function",

			Arguments =
			{
				{ Name = "isNumeric", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetPassword",
			Type = "Function",

			Arguments =
			{
				{ Name = "isPassword", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetSecureText",
			Type = "Function",

			Arguments =
			{
				{ Name = "isSecure", Type = "bool", Nilable = false, Default = false },
			},
		},
		{
			Name = "SetSecurityDisablePaste",
			Type = "Function",

			Arguments =
			{
			},
		},
		{
			Name = "SetSecurityDisableSetText",
			Type = "Function",

			Arguments =
			{
			},
		},
		{
			Name = "SetShadowColor",
			Type = "Function",

			Arguments =
			{
				{ Name = "colorR", Type = "number", Nilable = false },
				{ Name = "colorG", Type = "number", Nilable = false },
				{ Name = "colorB", Type = "number", Nilable = false },
				{ Name = "a", Type = "number", Nilable = true },
			},
		},
		{
			Name = "SetShadowOffset",
			Type = "Function",

			Arguments =
			{
				{ Name = "offsetX", Type = "number", Nilable = false },
				{ Name = "offsetY", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetSpacing",
			Type = "Function",

			Arguments =
			{
				{ Name = "fontHeight", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetText",
			Type = "Function",

			Arguments =
			{
				{ Name = "text", Type = "string", Nilable = false },
			},
		},
		{
			Name = "SetTextColor",
			Type = "Function",

			Arguments =
			{
				{ Name = "colorR", Type = "number", Nilable = false },
				{ Name = "colorG", Type = "number", Nilable = false },
				{ Name = "colorB", Type = "number", Nilable = false },
				{ Name = "a", Type = "number", Nilable = true },
			},
		},
		{
			Name = "SetTextInsets",
			Type = "Function",

			Arguments =
			{
				{ Name = "left", Type = "number", Nilable = false },
				{ Name = "right", Type = "number", Nilable = false },
				{ Name = "top", Type = "number", Nilable = false },
				{ Name = "bottom", Type = "number", Nilable = false },
			},
		},
		{
			Name = "SetVisibleTextByteLimit",
			Type = "Function",

			Arguments =
			{
				{ Name = "maxVisibleBytes", Type = "number", Nilable = false },
			},
		},
		{
			Name = "ToggleInputLanguage",
			Type = "Function",

			Arguments =
			{
			},
		},
	},

	Events =
	{
	},

	Tables =
	{
	},
};

APIDocumentation:AddDocumentationTable(SimpleEditBoxAPI);