
-- These are functions that were deprecated in 9.1.5, and will be removed in the next expansion.
-- Please upgrade to the updated APIs as soon as possible.

if not IsPublicBuild() then
	return;
end

-- Tooltips have moved to use the NineSlicePanel interface. Some old functionality remains (see SharedXML\SharedTooltipTemplates.lua)
do
	-- These functions are no longer meaningful
	TooltipBackdropTemplateMixin.OnBackdropLoaded = function() end;
	TooltipBackdropTemplateMixin.OnBackdropSizeChanged = function() end;
	TooltipBackdropTemplateMixin.GetEdgeSize = function() return 0 end;
	TooltipBackdropTemplateMixin.GetBackdropCoordValue = function() return 0 end;
	TooltipBackdropTemplateMixin.SetupTextureCoordinates = function() end;
	TooltipBackdropTemplateMixin.SetupPieceVisuals = function() end;
	TooltipBackdropTemplateMixin.HasBackdropInfo = function() return false end;
	TooltipBackdropTemplateMixin.GetBackdrop = function() return nil end;

	-- These functions will just apply the default backdrop and show the artwork
	TooltipBackdropTemplateMixin.ApplyBackdrop = function(self)
		local layout = NineSliceUtil.GetLayout("TooltipDefaultLayout");
		NineSliceUtil.ApplyLayout(self.NineSlice, layout);
		self.NineSlice:Show();
	end;
	TooltipBackdropTemplateMixin.SetBackdrop = function(self)
		local layout = NineSliceUtil.GetLayout("TooltipDefaultLayout");
		NineSliceUtil.ApplyLayout(self.NineSlice, layout);
		self.NineSlice:Show();
	end;

	-- This function will just hide the artwork
	TooltipBackdropTemplateMixin.ClearBackdrop = function(self)
		self.NineSlice:Hide();
	end;
end