WowScrollBarStepperButtonScriptsMixin = {};

function WowScrollBarStepperButtonScriptsMixin:OnEnter()
	self.Overlay:SetAtlas(self.overTexture, TextureKitConstants.UseAtlasSize);
	self.Overlay:Show();
end

function WowScrollBarStepperButtonScriptsMixin:OnLeave()
	self.Overlay:Hide();
end

function WowScrollBarStepperButtonScriptsMixin:OnMouseDown()
	if self:IsEnabled() then
		self.Texture:SetAtlas(self.downTexture, TextureKitConstants.UseAtlasSize);
		self.Texture:AdjustPointsOffset(-1, 0);
		self.Overlay:AdjustPointsOffset(-1, -1);
	end
end

function WowScrollBarStepperButtonScriptsMixin:OnMouseUp()
	if self:IsEnabled() then
		self.Texture:SetAtlas(self.normalTexture, TextureKitConstants.UseAtlasSize);
		self.Texture:AdjustPointsOffset(1, 0);
		self.Overlay:AdjustPointsOffset(1, 1);
	end
end

function WowScrollBarStepperButtonScriptsMixin:OnDisable()
	self.Texture:SetAtlas(self.disabledTexture, TextureKitConstants.UseAtlasSize);
	self.Texture:ClearPointsOffset();
end

function WowScrollBarStepperButtonScriptsMixin:OnEnable()
	self.Texture:SetAtlas(self.normalTexture, TextureKitConstants.UseAtlasSize);
end

function WowScrollBarStepperButtonScriptsMixin:OnDisable()
	self.Texture:SetAtlas(self.disabledTexture, TextureKitConstants.UseAtlasSize);
end

WowScrollBarThumbButtonScriptsMixin = {};

function WowScrollBarThumbButtonScriptsMixin:OnLoad()
	self:ApplyNormalAtlas();
end

function WowScrollBarThumbButtonScriptsMixin:OnEnter()
	self.Begin:SetAtlas(self.overBeginTexture, TextureKitConstants.UseAtlasSize);
	self.End:SetAtlas(self.overEndTexture, TextureKitConstants.UseAtlasSize);
	self.Middle:SetAtlas(self.normalMiddleTexture, TextureKitConstants.UseAtlasSize);
end

function WowScrollBarThumbButtonScriptsMixin:ApplyNormalAtlas()
	self.Begin:SetAtlas(self.normalBeginTexture, TextureKitConstants.UseAtlasSize);
	self.End:SetAtlas(self.normalEndTexture, TextureKitConstants.UseAtlasSize);
	self.Middle:SetAtlas(self.normalMiddleTexture, TextureKitConstants.UseAtlasSize);
end

function WowScrollBarThumbButtonScriptsMixin:OnLeave()
	self:ApplyNormalAtlas();
end

function WowScrollBarThumbButtonScriptsMixin:OnEnable()
	self:ApplyNormalAtlas();
end

function WowScrollBarThumbButtonScriptsMixin:OnDisable()
	self.Begin:SetAtlas(self.disabledBeginTexture, TextureKitConstants.UseAtlasSize);
	self.End:SetAtlas(self.disabledEndTexture, TextureKitConstants.UseAtlasSize);
	self.Middle:SetAtlas(self.normalMiddleTexture, TextureKitConstants.UseAtlasSize);
end

function WowScrollBarThumbButtonScriptsMixin:OnSizeChanged(width, height)
	-- C_Texture API not in classic.
	--local info = C_Texture.GetAtlasInfo(self.Middle:GetAtlas());
	local extent = 1024;
	if self.isHorizontal then
		self.Middle:SetWidth(width);
		local u = width / extent;
		self.Middle:SetTexCoord(0, u, 0, 1);
	else
		self.Middle:SetHeight(height);
		local v = height / extent;
		self.Middle:SetTexCoord(0, 1, 0, v);
	end
end

WowTrimScrollBarMixin = {};

function WowTrimScrollBarMixin:OnLoad()
	ScrollBarMixin.OnLoad(self);

	if self.hideBackground then
		self.Background:Hide();
	end
	
	if self.trackAlpha then
		self.Track:SetAlpha(self.trackAlpha);
	end
end